'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.elementIsClickedFactory = exports.checkElementIsClickedFactory = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _seleniumWebdriver = require('selenium-webdriver');

var _getWebElement = require('./getWebElement');

var _getWebElement2 = _interopRequireDefault(_getWebElement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkElementIsClickedFactory = exports.checkElementIsClickedFactory = function checkElementIsClickedFactory(getWebElementImpl) {
    return function (elementOrLocator) {
        return function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(driver) {
                var element, _ref2, _ref3, isDisplayed, isEnabled;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return getWebElementImpl(elementOrLocator, driver);

                            case 2:
                                element = _context.sent;
                                _context.next = 5;
                                return Promise.all([element.isDisplayed(), element.isEnabled()]);

                            case 5:
                                _ref2 = _context.sent;
                                _ref3 = (0, _slicedToArray3.default)(_ref2, 2);
                                isDisplayed = _ref3[0];
                                isEnabled = _ref3[1];

                                if (!(!isDisplayed || !isEnabled)) {
                                    _context.next = 11;
                                    break;
                                }

                                return _context.abrupt('return', null);

                            case 11:
                                return _context.abrupt('return', element.click().then(function () {
                                    return true;
                                }).catch(function () {
                                    return false;
                                }));

                            case 12:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, undefined);
            }));

            return function (_x) {
                return _ref.apply(this, arguments);
            };
        }();
    };
};

var elementIsClickedFactory = exports.elementIsClickedFactory = function elementIsClickedFactory(checkElementIsClicked) {
    return function (elementOrLocator) {
        return new _seleniumWebdriver.Condition('until element is clicked', checkElementIsClicked(elementOrLocator));
    };
};

exports.default = elementIsClickedFactory(checkElementIsClickedFactory(_getWebElement2.default));