'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.elementValueIsFactory = exports.checkElementValueIsFactory = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _seleniumWebdriver = require('selenium-webdriver');

var _getWebElement = require('./getWebElement');

var _getWebElement2 = _interopRequireDefault(_getWebElement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkElementValueIsFactory = exports.checkElementValueIsFactory = function checkElementValueIsFactory(getWebElementImpl) {
    return function (elementOrLocator, value) {
        return function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(driver) {
                var element;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return getWebElementImpl(elementOrLocator, driver);

                            case 2:
                                element = _context.sent;
                                return _context.abrupt('return', element.getAttribute('value').then(function (t) {
                                    return t === value;
                                }));

                            case 4:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, undefined);
            }));

            return function (_x) {
                return _ref.apply(this, arguments);
            };
        }();
    };
};

var elementValueIsFactory = exports.elementValueIsFactory = function elementValueIsFactory(checkElementValueIs) {
    return function (elementOrLocator, value) {
        return new _seleniumWebdriver.Condition('until element value is', checkElementValueIs(elementOrLocator, value));
    };
};

exports.default = elementValueIsFactory(checkElementValueIsFactory(_getWebElement2.default));