'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.elementsCountIsFactory = exports.checkElementsCountIsFactory = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _seleniumWebdriver = require('selenium-webdriver');

var _getWebElements = require('./getWebElements');

var _getWebElements2 = _interopRequireDefault(_getWebElements);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkElementsCountIsFactory = exports.checkElementsCountIsFactory = function checkElementsCountIsFactory(getWebElementsImpl) {
    return function (elementOrLocator, count) {
        return function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(driver) {
                var elements;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return getWebElementsImpl(elementOrLocator, driver);

                            case 2:
                                elements = _context.sent;
                                return _context.abrupt('return', Promise.resolve(elements && elements.length === count));

                            case 4:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, undefined);
            }));

            return function (_x) {
                return _ref.apply(this, arguments);
            };
        }();
    };
};

var elementsCountIsFactory = exports.elementsCountIsFactory = function elementsCountIsFactory(checkElementsCountIs) {
    return function (elementOrLocator, count) {
        return new _seleniumWebdriver.Condition('until elements count is', checkElementsCountIs(elementOrLocator, count));
    };
};

exports.default = elementsCountIsFactory(checkElementsCountIsFactory(_getWebElements2.default));