'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _seleniumWebdriver = require('selenium-webdriver');

exports.default = function (elementOrLocator, driver) {
    if (elementOrLocator instanceof _seleniumWebdriver.WebElement) {
        return Promise.resolve(elementOrLocator);
    }

    var locator = elementOrLocator;

    if (typeof elementOrLocator === 'string') {
        locator = _seleniumWebdriver.By.css(elementOrLocator);
    }

    return driver.wait(_seleniumWebdriver.until.elementLocated(locator)).then(function () {
        return driver.findElement(locator);
    });
};