'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.stalenessOfCondition = exports.checkStalenessOfFactory = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _seleniumWebdriver = require('selenium-webdriver');

var _transformElementCondition = require('./transformElementCondition');

var _transformElementCondition2 = _interopRequireDefault(_transformElementCondition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkStalenessOfFactory = exports.checkStalenessOfFactory = function checkStalenessOfFactory(stalenessOfImpl) {
    return function (element) {
        return function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(driver) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (element) {
                                    _context.next = 2;
                                    break;
                                }

                                return _context.abrupt('return', Promise.resolve(true));

                            case 2:
                                return _context.abrupt('return', stalenessOfImpl(element));

                            case 3:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, undefined);
            }));

            return function (_x) {
                return _ref.apply(this, arguments);
            };
        }();
    };
};

var stalenessOfCondition = exports.stalenessOfCondition = function stalenessOfCondition(element) {
    return new _seleniumWebdriver.Condition('until element is stale', checkStalenessOfFactory(_seleniumWebdriver.until.stalenessOf)(element));
};

exports.default = (0, _transformElementCondition2.default)(stalenessOfCondition);