'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.transformElementConditionFactory = exports.wrappedConditionFactory = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _seleniumWebdriver = require('selenium-webdriver');

var _getWebElement = require('./getWebElement');

var _getWebElement2 = _interopRequireDefault(_getWebElement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var wrappedConditionFactory = exports.wrappedConditionFactory = function wrappedConditionFactory(getWebElementImpl) {
    return function (conditionRequiringElement, elementOrLocator) {
        for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            args[_key - 2] = arguments[_key];
        }

        return function (driver) {
            return getWebElementImpl(elementOrLocator, driver).then(function (element) {
                var timeout = args.slice(-1)[0];
                var conditionArgs = args.slice(0, args.length - 1);

                var condition = conditionRequiringElement.apply(undefined, [element].concat((0, _toConsumableArray3.default)(conditionArgs)));

                return driver.wait(condition, timeout);
            });
        };
    };
};

var transformElementConditionFactory = exports.transformElementConditionFactory = function transformElementConditionFactory(getWebElementImpl) {
    return function (conditionRequiringElement) {
        return function (elementOrLocator) {
            for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
            }

            return new _seleniumWebdriver.Condition('', wrappedConditionFactory(getWebElementImpl).apply(undefined, [conditionRequiringElement, elementOrLocator].concat(args)));
        };
    };
};

exports.default = transformElementConditionFactory(_getWebElement2.default);